Fix the daemon test when running it as root.
[rsync/rsync.git] / testsuite / rsync.fns
CommitLineData
d820215b
MP
1#! /bin/sh
2
3# Copyright (C) 2001 by Martin Pool <mbp@samba.org>
4
5# General-purpose test functions for rsync.
3a4c683f 6
0154b302
MP
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License version
9# 2 as published by the Free Software Foundation.
10#
11# This program is distributed in the hope that it will be useful, but
12# WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
14# Lesser General Public License for more details.
15#
16# You should have received a copy of the GNU Lesser General Public
17# License along with this program; if not, write to the Free Software
18# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
19
6f481bb0 20tmpdir="$scratchdir"
e3442095
WD
21fromdir="$tmpdir/from"
22todir="$tmpdir/to"
23chkdir="$tmpdir/chk"
3a4c683f 24
fc29efc3
WD
25# For itemized output:
26all_plus='+++++++++'
27allspace=' '
28dots='.....' # trailing dots after changes
29
2094283b 30# Berkley's nice.
96553aa7 31PATH="$PATH:/usr/ucb"
2094283b 32
21706678 33if diff -u "$suitedir/rsync.fns" "$suitedir/rsync.fns" >/dev/null 2>&1; then
84229c7a
WD
34 diffopt="-u"
35else
36 diffopt="-c"
37fi
38
a98cad00
WD
39HOME="$scratchdir"
40export HOME
41
3a4c683f
MP
42runtest() {
43 echo $ECHO_N "Test $1: $ECHO_C"
501972bf
MP
44 if eval "$2"
45 then
6f481bb0 46 echo "$ECHO_T done."
501972bf
MP
47 return 0
48 else
6f481bb0 49 echo "$ECHO_T failed!"
501972bf
MP
50 return 1
51 fi
3a4c683f
MP
52}
53
844810d6
WD
54set_cp_destdir() {
55 while test $# -gt 1; do
56 shift
57 done
58 destdir="$1"
59}
60
61# Perform a "cp -p", making sure that timestamps are really the same,
62# even if the copy rounded microsecond times on the destination file.
63cp_touch() {
64 cp -p "${@}" || test_fail "cp -p failed"
65 if test $# -gt 2 -o -d "$2"; then
66 set_cp_destdir "${@}" # sets destdir var
67 while test $# -gt 1; do
68 destname="$destdir/`basename $1`"
69 touch -r "$destname" "$1" "$destname"
70 shift
71 done
72 else
73 touch -r "$2" "$1" "$2"
74 fi
75}
76
757287d8
WD
77# Call this if you want to filter out verbose messages (-v or -vv) from
78# the output of an rsync run (whittling the output down to just the file
79# messages). This isn't needed if you use -i without -v.
80filter_outfile() {
81 sed -e '/^building file list /d' \
9544261a 82 -e '/^sending incremental file list/d' \
757287d8
WD
83 -e '/^created directory /d' \
84 -e '/^done$/d' \
85 -e '/ --whole-file$/d' \
86 -e '/^total: /d' \
332cf6df
WD
87 -e '/^client charset: /d' \
88 -e '/^server charset: /d' \
757287d8
WD
89 -e '/^$/,$d' \
90 <"$outfile" >"$outfile.new"
91 mv "$outfile.new" "$outfile"
92}
93
3a4c683f
MP
94printmsg() {
95 echo "$1"
96}
97
6773a779 98rsync_ls_lR() {
db9c9e27 99 find "$@" -print | sort | sed 's/ /\\ /g' | xargs "$TOOLDIR/tls" $TLS_ARGS
dfef3f10
MP
100}
101
18d7e9f4 102check_perms() {
eace352b
WD
103 perms=`"$TOOLDIR/tls" "$1" | sed 's/^[-d]\(.........\).*/\1/'`
104 if test $perms = $2; then
105 return 0
106 fi
107 echo "permissions: $perms on $1"
108 echo "should be: $2"
109 test_fail "failed test $3"
18d7e9f4
WD
110}
111
dfef3f10
MP
112rsync_getgroups() {
113 "$TOOLDIR/getgroups"
57835c00
MP
114}
115
116
e052b21f 117####################
6f481bb0 118# Build test directories $todir and $fromdir, with $fromdir full of files.
e052b21f 119
3a4c683f 120hands_setup() {
501972bf 121 # Clean before creation
6f481bb0
WD
122 rm -rf "$fromdir"
123 rm -rf "$todir"
3d807132 124
e3442095
WD
125 [ -d "$tmpdir" ] || mkdir "$tmpdir"
126 [ -d "$fromdir" ] || mkdir "$fromdir"
127 [ -d "$todir" ] || mkdir "$todir"
3a4c683f 128
e052b21f
MP
129 # On some BSD systems, the umask affects the mode of created
130 # symlinks, even though the mode apparently has no effect on how
131 # the links behave in the future, and it cannot be changed using
132 # chmod! rsync always sets its umask to 000 so that it can
133 # accurately recreate permissions, but this script is probably run
134 # with a different umask.
135
136 # This causes a little problem that "ls -l" of the two will not be
137 # the same. So, we need to set our umask before doing any creations.
138
3a4c683f 139 # set up test data
6f481bb0
WD
140 touch "$fromdir/empty"
141 mkdir "$fromdir/emptydir"
e8ca5901 142
571a4b26 143 # a hundred lines of text or so
6f481bb0 144 rsync_ls_lR "$srcdir" > "$fromdir/filelist"
3a4c683f 145
6f481bb0 146 echo $ECHO_N "This file has no trailing lf$ECHO_C" > "$fromdir/nolf"
0154b302 147 umask 0
6f481bb0 148 ln -s nolf "$fromdir/nolf-symlink"
4c80c473 149 umask 022
0154b302 150
db10766a 151 cat "$srcdir"/*.c > "$fromdir/text"
6f481bb0
WD
152 mkdir "$fromdir/dir"
153 cp "$fromdir/text" "$fromdir/dir"
154 mkdir "$fromdir/dir/subdir"
155 echo some data > "$fromdir/dir/subdir/foobar.baz"
156 mkdir "$fromdir/dir/subdir/subsubdir"
a7a1cc2c
WD
157 if [ -r /etc ]; then
158 ls -ltr /etc > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
159 else
160 ls -ltr / > "$fromdir/dir/subdir/subsubdir/etc-ltr-list"
161 fi
6f481bb0 162 mkdir "$fromdir/dir/subdir/subsubdir2"
a7a1cc2c
WD
163 if [ -r /bin ]; then
164 ls -lt /bin > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
165 else
166 ls -lt / > "$fromdir/dir/subdir/subsubdir2/bin-lt-list"
167 fi
7d691654 168
8f98c608 169# echo testing head:
6f481bb0 170# ls -lR "$srcdir" | head -10 || echo failed
3a4c683f 171}
3fedd74b
MP
172
173
99cdaff7
MP
174####################
175# Many machines do not have "mkdir -p", so we have to build up long paths.
176# How boring.
5ef8c5c6 177makepath() {
d1798a2f
WD
178 for p in "${@}"; do
179 (echo " makepath $p"
180
99cdaff7
MP
181 # Absolut Unix.
182 if echo $p | grep '^/' >/dev/null
183 then
184 cd /
185 fi
186
d1798a2f 187 # This will break if $p contains a space.
99cdaff7
MP
188 for c in `echo $p | tr '/' ' '`
189 do
112e7311
MP
190 if [ -d "$c" ] || mkdir "$c"
191 then
192 cd "$c" || return $?
193 else
194 echo "failed to create $c" >&2; return $?
195 fi
d1798a2f
WD
196 done)
197 done
99cdaff7
MP
198}
199
200
201
3fedd74b
MP
202###########################
203# Run a test (in '$1') then compare directories $2 and $3 to see if
204# there are any difference. If there are, explain them.
205
f494f286
MP
206# So normally basically $1 should be an rsync command, and $2 and $3
207# the source and destination directories. This is only good when you
208# expect to transfer the whole directory exactly as is. If some files
209# should be excluded, you might need to use something else.
210
3fedd74b 211checkit() {
3fedd74b 212 failed=
3fedd74b 213
cf72f204
MP
214 # We can just write everything to stdout/stderr, because the
215 # wrapper hides it unless there is a problem.
216
217 echo "Running: \"$1\""
218 eval "$1"
3fedd74b
MP
219 status=$?
220 if [ $status != 0 ]; then
221 failed="YES";
222 fi
223
cf72f204
MP
224 echo "-------------"
225 echo "check how the directory listings compare with diff:"
226 echo ""
6f481bb0
WD
227 ( cd "$2" && rsync_ls_lR . ) > "$tmpdir/ls-from"
228 ( cd "$3" && rsync_ls_lR . ) > "$tmpdir/ls-to"
229 diff $diffopt "$tmpdir/ls-from" "$tmpdir/ls-to" || failed=YES
30688bf1
WD
230
231 echo "-------------"
232 echo "check how the files compare with diff:"
233 echo ""
234 if [ "x$4" != x ]; then
235 echo " === Skipping (as directed) ==="
236 else
237 diff -r $diffopt "$2" "$3" || failed=YES
238 fi
239
240 echo "-------------"
6f481bb0 241 if [ -z "$failed" ] ; then
3fedd74b
MP
242 return 0
243 else
3fedd74b
MP
244 return 1
245 fi
246}
247
863dff51 248
4a7cb3e8 249build_rsyncd_conf() {
d2094cc3
MP
250 # Build an appropriate configuration file
251 conf="$scratchdir/test-rsyncd.conf"
252 echo "building configuration $conf"
253
254 port=2612
255 pidfile="$scratchdir/rsyncd.pid"
256 logfile="$scratchdir/rsyncd.log"
e5255195 257 hostname=`uname -n`
d2094cc3 258
aa381148
WD
259 uid_setting='uid = 0'
260 gid_setting='gid = 0'
261 case `id -u` in
262 0) ;;
263 *)
264 # Non-root cannot specify uid & gid settings
265 uid_setting="#$uid_setting"
266 gid_setting="#$gid_setting"
267 ;;
268 esac
269
6f481bb0 270 cat >"$conf" <<EOF
3aae15ec 271# rsyncd configuration file autogenerated by $0
d2094cc3 272
3aae15ec
MP
273pid file = $pidfile
274use chroot = no
9585b276 275munge symlinks = no
e73eed85 276hosts allow = localhost 127.0.0.0/24 192.168.0.0/16 10.0.0.0/8 $hostname
3aae15ec 277log file = $logfile
2ae4126a
WD
278log format = %i %h [%a] %m (%u) %l %f%L
279transfer logging = yes
0e9c3564 280exclude = ? foobar.baz
951e826b 281max verbosity = 4
aa381148
WD
282$uid_setting
283$gid_setting
98c1b325 284
2e6c7f45 285[test-from]
6f481bb0 286 path = $fromdir
3aae15ec 287 read only = yes
0e9c3564 288 comment = r/o
d2094cc3 289
2e6c7f45 290[test-to]
6f481bb0 291 path = $todir
3aae15ec 292 read only = no
0e9c3564 293 comment = r/w
2ae4126a
WD
294
295[test-scratch]
296 path = $scratchdir
297 read only = no
0e9c3564
WD
298
299[test-hidden]
300 path = $fromdir
301 list = no
d2094cc3 302EOF
2d8f9b1d
WD
303
304 # Build a helper script to ignore exit code 23
305 ignore23="$scratchdir/ignore23"
306 echo "building help script $ignore23"
307
308 cat >"$ignore23" <<'EOT'
309if "${@}"; then
310 exit
311fi
312
313ret=$?
314
315if test $ret = 23; then
316 exit
317fi
318
319exit $ret
320EOT
321chmod +x "$ignore23"
d2094cc3
MP
322}
323
324
3cd2af41 325build_symlinks() {
3cd2af41
MP
326 mkdir "$fromdir"
327 date >"$fromdir/referent"
328 ln -s referent "$fromdir/relative"
329 ln -s "$fromdir/referent" "$fromdir/absolute"
330 ln -s nonexistent "$fromdir/dangling"
1db8b61d 331 ln -s "$srcdir/rsync.c" "$fromdir/unsafe"
3cd2af41
MP
332}
333
334test_fail() {
335 echo "$@" >&2
336 exit 1
337}
338
a217ad30
MP
339test_skipped() {
340 echo "$@" >&2
6f481bb0 341 echo "$@" > "$tmpdir/whyskipped"
a217ad30
MP
342 exit 77
343}
344
be2f866b
MP
345# It failed, but we expected that. don't dump out error logs,
346# because most users won't want to see them. But do leave
347# the working directory around.
348test_xfail() {
349 echo "$@" >&2
350 exit 78
351}
352
d1239eae
MP
353# Determine what shell command will appropriately test for links.
354ln -s foo "$scratchdir/testlink"
355for cmd in test /bin/test /usr/bin/test /usr/ucb/bin/test /usr/ucb/test
356do
357 for switch in -h -L
358 do
359 if $cmd $switch "$scratchdir/testlink" 2>/dev/null
360 then
361 # how nice
362 TEST_SYMLINK_CMD="$cmd $switch"
363 # i wonder if break 2 is portable?
364 break 2
365 fi
366 done
367done
cca4e067
MP
368# ok, now get rid of it
369rm "$scratchdir/testlink"
d1239eae
MP
370
371
372if [ "x$TEST_SYMLINK_CMD" = 'x' ]
373then
374 test_fail "Couldn't determine how to test for symlinks"
375else
376 echo "Testing for symlinks using '$TEST_SYMLINK_CMD'"
377fi
378
379
d96d3893
MP
380# Test whether something is a link, allowing for shell peculiarities
381is_a_link() {
d1239eae
MP
382 # note the variable contains the first option and therefore is not quoted
383 $TEST_SYMLINK_CMD "$1"
d96d3893
MP
384}
385
77867907
MP
386
387# We need to set the umask to be reproducible. Note also that when we
388# do some daemon tests as root, we will setuid() and therefore the
389# directory has to be writable by the nobody user in some cases. The
390# best thing is probably to explicitly chmod those directories after
391# creation.
392
ad301e48 393umask 022